#! /bin/csh -f
#
#   Plot R-factors from a REFMAC log in xloggraph format
#
#
alias nawk /usr/bin/nawk
if(`uname` == Linux) alias nawk awk
if(! $?CBIN) set CBIN = "/programs/ccp4/bin"

set logs
set sort = rt
foreach arg ( $* )
    if($arg =~ paste*) then
	set sort = ""
    endif
end
echo ""
ls -1$sort $*
set i = 1
echo ""
echo "<html><pre>Stats"
echo '<applet width=" 700" height=" 300" code="JLogGraph.class" codebase="'$CBIN'"><param name="table" value="'
echo ' $TABLE : Stats:'
echo ' $GRAPHS:R factors:A:1, 2, 3: '
echo ':R diff:A:1, 4: '
echo ':R cryst:A:1, 2: '
echo ':R free:A:1, 3: '
echo ':rms bond length deviation:N:1, 5: '
echo ':rms angle deviation:N:1, 6: '
echo ':number of atoms:A:1, 7: $$ '
onintr finish
if($#argv == 1) then
    echo 'cycle Rcryst  Rfree  Rfree-Rcrys  bonds angles  atoms $$ '
    echo '$$ '
    # do refinement cycles
    cat $1 |\
    nawk '/Number of atoms read/{atoms = $NF} \
	/Estimated bond angle/{angles=$NF}  /NUMBER   DIST   DELTA/{getline; bonds=$5} \
	/Bond distances: refined atoms/{bonds=$6} \
	/Bond angles  : refined atoms/{angles=$7} \
	/Number of atoms       /{atoms=$NF} \
	/weighted/ || /based on / {next}\
	/all[_ ]R[_ ]factor/{R = $NF; ++i} \
	/ree[_ ]R[_ ]factor/{RF = $NF} \
	/Overall figure of merit/ || /Precision indication from R values/{fulline=1}\
	fulline{fulline=0;\
	   printf "%-5d %6.3f %6.3f %6.3f       %6.3f %4.1f  %6d \n",  i, R*100, RF*100, 100*(RF-R), bonds, angles, atoms}'
else
    echo 'pdb  Rcryst  Rfree  Rfree-Rcrys  bonds angles  atoms $$ '
    echo '$$ '
    foreach X ( `ls -1$sort $* ` )
	set number = `echo $X | nawk '{for(i=1;i<length($1);++i){ c=substr($1,i,1); if(c ~ /[0-9]/)printf c }}'`

	# speed things up a bit
	set atoms = `nawk '/Number of atoms read/ || /Number of atoms       /{print $NF; exit}' $X`
	if("$atoms" == "") continue
	tail -4000 $X |\
	nawk -v number=$number -v atoms=$atoms '/all[_ ]R[_ ]factor/{R = $NF} /Free[_ ]R[_ ]factor/{RF = $NF} \
             /Estimated bond angle/{angles=$NF}  /NUMBER   DIST   DELTA/{getline; bonds=$5} \
	     /Bond distances: refined atoms/{bonds=$6} \
	     /Bond angles  : refined atoms/{angles=$7} \
	    END{if(R=="") exit; \
	    printf "%-5d %6.3f %6.3f %6.3f      %6.3f %4.1f  %6d \n", number, R*100, RF*100, (RF-R)*100, bonds, angles, atoms}' 
    end
endif

finish:
echo '$$'
echo '"><b>For inline graphs use a Java browser</b></applet>'
echo "</pre></html>"
