#! /bin/csh -f
#
#  Wedger Elves automatically generated mosflm script
#
# 
# option to integrate after refining
set END = "END"
if("$1" =~ integ*) set END = ""
#
# temporary file prefix
set tempfile = frame_1_temp
set outfile  = raw.mtz
#
#
/programs/mosflm/ipmosflm HKLOUT ${tempfile}.mtz	\
         SPOTOD  ${tempfile}.spotod	\
         SUMMARY logs/mosflm.xlog	\
         COORDS  ${tempfile}.coords << eof-ipmosflm
#
TITLE Raw data wedge from frame_1_???.img 1 to 100 at lambda= 0.9793
#
GENFILE ${tempfile}.gen
#
# the following keywords were not understood by Wedger Elves, but passed on
# because they resemble mosflm commands.
# ----
POSTREF ADD 30
REFINE CELL

# ----

# Detector parameters (range, quantum gain, etc.)
SCANNER omega 90 ROTATION horiz ANTI FAST horiz ORIGIN UR RECTANG TYPE ADSC
OVERLOAD CUTOFF 60000
GAIN            .130
LIMITS RMAX 133 YMAX 188 XMAX 188 xscan 188 yscan 188

# Beam parameters (i.e. (delta-lambda)/lambda, H,V divervence in degrees)
WAVELENGTH    0.9793
DISPERSION    0.00025
DIVERGENCE    0.10 0.02
POLARISATION  SYNCHROTRON 0.9

# Alignment parameters
DISTANCE      175.559
BEAM          93.7373 92.6879
TWOTHETA      0
MATRIX        best.mat
MISSETS       0.025273 -0.007051 0.043778 
NEWMATRIX     postref.mat

# Crystal parameters
CELL          68.0538 99.237 106.499 90 96.3513 90
SYMMETRY      P21
RESOLUTION    3
MOSAIC        0.308723

# Frame filename breakdown
DIRECTORY     /data/user/frames
IDENTIFIER    frame_1
EXTENSION     img
#
# To run mosflm interactively,
# uncomment the following lines (and DON'T redirect output)
#IMAGE frame_1_001.img PHI 70 TO 71
#GO
#END
#PLOT
#
REFI RESID 100
POSTREF FIX ALL
REFINE  FIX YSCALE
# Processing commands: 
POSTREF SEGMENTS 7
PROCESS 1 TO 4 START 70 ANGLE 1  ADD 0
go
PROCESS 16 TO 19 START 85 ANGLE 1  ADD 0
go
PROCESS 31 TO 34 START 100 ANGLE 1  ADD 0
go
PROCESS 46 TO 49 START 115 ANGLE 1  ADD 0
go
PROCESS 61 TO 64 START 130 ANGLE 1  ADD 0
go
PROCESS 76 TO 79 START 145 ANGLE 1  ADD 0
go
PROCESS 97 TO 100 START 166 ANGLE 1  ADD 0
go

# to perform full integration, either put the word "integ" on the command line,
# or remove the $END on the next line
$END
PROCESS 1 to 100 START 70 ANGLE 1 ADD 0
GO
END

END
eof-ipmosflm
set mosflm_status = $status

# update mtz only after run is finished
if((! $mosflm_status)&&(-e ${tempfile}.mtz)) then 
    mv ${tempfile}.mtz ${outfile}
endif

# Life's messy, clean it up.
rm -f ${tempfile}.spotod >& /dev/null
rm -f ${tempfile}.coord  >& /dev/null
rm -f ${tempfile}.gen    >& /dev/null
rm -f ${tempfile}.mtz    >& /dev/null
ls fort* >& /dev/null
if(! $status) rm -f fort*


exit $mosflm_status
